﻿/**
	@author	Manny Tan mannytan@uncontrol.com
	@company uncontrol
	@version 2006-10-14
*/
import flash.display.BitmapData;
import com.method.movieclip.ObservableMovieClip;
import com.method.event.Event;

class com.Perlin extends ObservableMovieClip{
	
	private var total:Number;		// public total values (redo bitmap)
	private var speed:Number;		// public speed
	private var octaves:Number; 	// public octaves
	private var seed:Number;		// public seed
	private var count:Number;		// private 

	private var bitmapProxy:BitmapData
	private var mcProxy:MovieClip
// ===========================================================
// - CONSTRUCTOR
// ===========================================================
	public function Perlin() {
		this.setClassDescription('com.Perlin');
		// trace('Perlin Class :: ' + this);

		setTotal(10);		
		setSpeed(1);
		setOctaves(10); 			
		setSeed(Math.random()*10);
		count = 0;
		
		bitmapProxy = new BitmapData(total, 1, false, 0x000000);
		mcProxy = this.createEmptyMovieClip("mc", this.getNextHighestDepth());
		
		mcProxy._xscale = 1000;
		mcProxy._yscale = 1000;
		mcProxy._visible = false;
		mcProxy.attachBitmap(bitmapProxy, this.getNextHighestDepth());	
  	}
	
// ===========================================================
// - PUBLIC METHODS
// ===========================================================
	public function step():Array{
		var block = new Array();
		var colorVal:Number;
		count+=speed;
		bitmapProxy.perlinNoise(total, 1, octaves, seed, false, true, 1, true, {x:count,y:0});
		
		for(var i=0;i<total;i++){
			colorVal = Number((bitmapProxy.getPixel32(i, 0) & 0xFF).toString(10)); // converts hex of blue to 0-256
			block[i] = int(colorVal/256*10000)/10000;	// adjusts values to 4 decimal places, less caculating needed
		}
		return block;
	}

	public function setOctaves(arg:Number):Void{
		octaves = arg;
	}
	public function setSpeed(arg:Number):Void{
		speed = arg;
	}	
	public function setSeed(arg:Number):Void{
		seed = arg;
	}	
	public function setTotal(arg:Number):Void{
		total = arg;
		bitmapProxy = new BitmapData(total, 1, false, 0x000000);
		mcProxy.attachBitmap(bitmapProxy, this.getNextHighestDepth());	
	}
// ===========================================================
// - PRIVATE METHODS
// ===========================================================
 
}