﻿/**
	@author	Manny Tan mannytan@uncontrol.com
	@company uncontrol
	@version 2006-10-14
*/
import com.method.movieclip.ObservableMovieClip;
import com.method.event.Event;
import com.Perlin;
class com.Starfish extends ObservableMovieClip {
	private var $context:MovieClip;
	
	private var $strokerWidth:Number;
	private var $colorId:Number;
	private var $strokerNum:Number;
	private var total:Number;
	private var TWO_PI:Number = Math.PI*2;
	private var a:Array;
	private var b:Array;
	private var b1:Array;
	private var c:Array;
	private var c1:Array;
	private var d:Array;
	private var d1:Array;
	private var b_spread:Number;		
	private var noiseSpread:Perlin;
	private var noiseRadius:Perlin;

// ===========================================================
// - CONSTRUCTOR
// ===========================================================
	public function Starfish() {
        this.setClassDescription('com.Starfish');
		trace('Starfish Class :: ' + this);
        this.$context = this;
		noiseSpread = new Perlin();
		noiseRadius = new Perlin();
  	}

// ===========================================================
// - PUBLIC METHODS
// ===========================================================
	public function init(){
		stroke(0x0066FF);
		strokeWidth(1);
		total = 8;
	}

	public function display(ext_total:Number, ext_b_radius:Number, ext_c_radius:Number, ext_b_offset:Number, ext_c_offset:Number, ext_b_spread:Number, BC_Pos_Array:Array){
		this.$context.clear();
		var p:Number;
		var aOffset:Number;
		var bOffset:Number;
		var ayDelta:Number;
		var axDelta:Number;
		var byDelta:Number;
		var bxDelta:Number;

		var aSlope:Number;
		var bSlope:Number;
		
		var pRangeB:Number;
		var pRangeC:Number;
		
		var b_offset = ext_b_offset;
		var c_offset = ext_c_offset;
			
		var b_spread = ext_b_spread;
		
		var b_radius = ext_b_radius;
		var c_radius = ext_c_radius;
		
		var total = ext_total;
		var vis = 1;//_parent.vis;
		
		var b_X = BC_Pos_Array[0];// _parent.b_X;
		var b_Y = BC_Pos_Array[1];// _parent.b_Y;
		
		var c_X = BC_Pos_Array[2];// _parent.c_X;
		var c_Y = BC_Pos_Array[3];// _parent.c_Y;
		
		a = new Array();
		b = new Array();
		b1 = new Array();
		c = new Array();
		c1 = new Array();
		d = new Array();
		
		noiseSpread.setTotal(total);
		noiseSpread.setOctaves(_parent.pOctavesB);
		noiseSpread.setSpeed(_parent.pSpeedB);

		noiseRadius.setTotal(total);
		noiseRadius.setOctaves(_parent.pOctavesC);
		noiseRadius.setSpeed(_parent.pSpeedC);		
		
		pRangeB = _parent.pRangeB;
		pRangeC = _parent.pRangeC;
		
		var noiseSpreadArray:Array = noiseSpread.step();
		var noiseRadiusArray:Array = noiseRadius.step();
		for(var i=0;i<total;i++){

			p = i/total;
			b_spread = noiseSpreadArray[i]*pRangeB + _parent.b_spread;
			c_radius = noiseRadiusArray[i]*pRangeC + _parent.c_radius;
			b[i] = new Object();
			b[i].x1 = Math.sin((p+b_spread+b_offset)*TWO_PI)*(b_radius) + b_X; 
			b[i].y1 = Math.cos((p+b_spread+b_offset)*TWO_PI)*(b_radius) + b_Y; 
			
			b[i].x2 = Math.sin((p-b_spread+b_offset)*TWO_PI)*(b_radius) + b_X;
			b[i].y2 = Math.cos((p-b_spread+b_offset)*TWO_PI)*(b_radius) + b_Y; 
			
			c[i] = new Object();
			c[i].x = Math.sin((p+c_offset)*TWO_PI)*(c_radius) + c_X; 
			c[i].y = Math.cos((p+c_offset)*TWO_PI)*(c_radius) + c_Y; 
			
		}

		b1 = shiftArray(b);
		c1 = shiftArray(c);
		
		for(var i=0;i<total;i++){
			ayDelta = b[i].y1 - c[i].y;
			axDelta = b[i].x1 - c[i].x;
			byDelta = b1[i].y2 - c1[i].y;
			bxDelta = b1[i].x2 - c1[i].x;
			
			aSlope = ayDelta/axDelta;
			bSlope = byDelta/bxDelta;
			
			aOffset = ayDelta*(-c[i].x)/axDelta + c[i].y;
			bOffset = byDelta*(-c1[i].x)/bxDelta + c1[i].y;

			d[i] = new Object();
			d[i].x = (bOffset-aOffset)/(aSlope-bSlope);
			d[i].y = (aOffset*bSlope-bOffset*aSlope)/(bSlope-aSlope);
		}
		if(vis>=1){
			stroke(0x000000);
			this.$context.beginFill(this.$colorId, 100);
			this.$context.lineStyle(this.$strokerWidth, this.$colorId, 0);
			this.$context.moveTo(b[0].x1, b[0].y1);
			for(var i=0;i<total;i++){
			this.$context.curveTo(d[i].x,d[i].y,b1[i].x2,b1[i].y2);
			this.$context.curveTo(c1[i].x,c1[i].y,b1[i].x1,b1[i].y1);
			}
		}
		if(vis>=2){
			for(var i=0;i<total;i++){
				stroke(0x660000);
				point(a[i].x,a[i].y);
				
				stroke(0xFF6600);
				point(b[i].x1,b[i].y1);
				point(b[i].x2,b[i].y2);
				
				stroke(0x0066cc);
				point(c[i].x,c[i].y);
		
				stroke(0xCCCCCC);
				point(d[i].x,d[i].y);
				
				line(c[i].x,c[i].y,d[i].x,d[i].y);
				line(c1[i].x,c1[i].y,d[i].x,d[i].y);
			}
		}

	}


// ===========================================================
// - PRIVATE METHODS
// ===========================================================
	/**
	*	shifts array's last position to first
	*	@param og original array
	*/	
	private function shiftArray(og:Array):Array{
		var ogTotal = og.length-1;
		var shifted:Array = new Array();
		for(var i=0;i<ogTotal;i++){
			shifted[i] = og[i+1];
		}	
		shifted[ogTotal] = og[0];
		return shifted;
	}
	/**
	*	traces array object value
	*	@param inp array object
	*/	
	private function tracer(inp:Array):Void{
		var temp = new Array();
		for(var i=0;i<inp.length;i++){
			temp[i] = inp[i].x;
		}
		trace(temp);
	}
	
	/**
	*	draws a line on this.$context
	*	@param x
	* *	@param y
	* *	@param xy
	* *	@param yy
	*/	
	private function line(x:Number,y:Number,xx:Number,yy:Number):Void {
		this.$context.beginFill(null);
		this.$context.lineStyle(this.$strokerWidth, this.$colorId, 100);
		this.$context.moveTo(x, y);
		this.$context.lineTo(xx, yy);
		this.$context.endFill();
	}
	
	/**
	*	draws a point this.$context
	*	@param x
	*	@param y
	*/
	private function point(x:Number,y:Number):Void {
		var z=2;
		this.$context.beginFill(this.$colorId, 100);
		this.$context.lineStyle(this.$strokerWidth, this.$colorId, 0);
		this.$context.moveTo(x+z, y+z);
		this.$context.lineTo(x-z, y+z);
		this.$context.lineTo(x-z, y-z);
		this.$context.lineTo(x+z, y-z);
		this.$context.endFill();
	}
	
	/**
	*	changes stroke width
	*	@param arg width
	*/
	private function strokeWidth(arg:Number):Void{
		this.$strokerWidth = arg;
	}
	
	/**
	*	changes stroke color
	*	@param arg hex value
	*/
	private function stroke(arg:Number):Void{
		this.$colorId = arg;
	}
// ===========================================================
// - EVENTS
// ===========================================================
 
}